package com.hik.project;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.roots.ProjectRootManager;
import com.intellij.openapi.ui.Messages;
import com.intellij.openapi.vfs.VirtualFile;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.stream.Collectors;

/**
 * @menu: GetContentSourceRootAction
 * @author: xieshixiang@hikcreate.com
 * @time：2020/10/13 9:31
 **/
public class GetContentSourceRootAction extends AnAction {
    @Override
    public void actionPerformed(@NotNull AnActionEvent e) {
        Project project = e.getProject();
        VirtualFile[] virtualFiles = ProjectRootManager.getInstance(project).getContentSourceRoots();
        String sourceRoot = Arrays.stream(virtualFiles).map(VirtualFile::getUrl).collect(Collectors.joining("\n"));
        Messages.showInfoMessage("Source roots for project: " + project.getName() + " are " + sourceRoot, "Project " +
                "Properties");
    }
}